/*
	File:		SimpleThread.c

	Contains:	demo program to test the shell's behaviour when invoking threads using '@'

	Written by:	Cyrus Hazari

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

	To Do:
*/

#define SPAWN_THREAD 1

/*	------------------------------	*/
/*			INCLUDE FILES			*/
/*	------------------------------	*/
#ifdef SPAWN_THREAD
#include "FileTest.h"
#include "directory.h"
#include "directoryfunctions.h"
#include "data.h"
#include "item.h"
#endif
#include "portfolio.h"
#include "event.h"

#ifdef SPAWN_THREAD
/* log file */
char	gLogFile[64];
Boolean gUseLogFile;
FILE	*gTheFile;
/* Parameter-checking */
Boolean gInvalidArg;
#endif

int main( int argc, char *argv[] )
{
	int32	x,y;
#ifdef SPAWN_THREAD
	int32		theResult;
	Err			theErr;
	CodeHandle	codeHandle;
#endif
	
	x = 1;
	y = 2;
	y += x;

#ifdef SPAWN_THREAD
	pipeData("Loading /remote/Return_int32_Thread .....\n");
	theErr = LoadCode("/remote/Return_int32_Thread", &codeHandle);
	pipeData("                      error returned = %x \n", theErr);
	if (theErr < 0)
	{
		pipeData("fail embedded LoadCode(/remote/Return_int32_Thread)\n");
	}
	else
	{
		pipeData("Executing embedded /remote/Return_int32_Thread .....\n");
		theResult = ExecuteAsThread( codeHandle, 0, NULL, "Cyrus_SubThread", 199 );
		pipeData("                      result returned = %x \n", theResult);
		if (theResult < 0)
		{
			pipeData("fail embedded ExecuteAsThread(/remote/Return_int32_Thread)\n");
			pipeData("                      error returned = %x \n",theResult);
			PrintfSysErr(theResult);
		}
	}
//	pipeData("Unloading embedded /remote/Return_int32_Thread .....\n");
//	UnloadCode( codeHandle );
#endif

//	theErr = SleepSeconds( 20 );	
//	for(x=0;x<1000000;x++);
	for(x=0;x<100000;x++);
	
}
