 
#include "common.h"

extern	Boolean gUseLogFile;
extern	FILE	*gTheFile;


long	power(long x, long y)
{
	 long i, p;
	 
	 p = 1;
	 for ( i = 1; i <= y; ++i)
	 	p = p * x;
		
	return p;
}


void 	printd(int32 n, FILE *theFile)
{
	if (n/10)
		printd(n/10,theFile);
	 putc((char) n%10 + '0',theFile);
}


void 	printHex(int32 n, FILE *theFile)
{
	long	indx;
	char	*hexChar;
	
	hexChar = "0123456789abcdef";
	
	for (indx = 7; indx >= 0; indx--)
	{
		putc( hexChar[((n) >> indx * 4) & 0xF], theFile);	
	}
}


void	pipeData(char *formatStr,...)
{
	va_list		ap;
	char		*p,*sval,schar;
	int32		ival;
	
	va_start(ap, formatStr);
	for ( p = formatStr ; *p ; p++ )
	{
		if (*p == 0x0A) // look explicitly for a newline hex 10 or '\n'
		{
			if (!gUseLogFile) kprintf("\n");
			else putc(0x0D, gTheFile);
			
			continue;
		}
		if (*p != '%')
		{
			if (!gUseLogFile) kprintf("%c",*p);
			else putc(*p, gTheFile);
			
			continue;
		}
		switch(*++p)
		{
			case 'd':
			case 'i':
			case 'u':
				ival = va_arg(ap, int32);
				if (!gUseLogFile) kprintf("%i",ival);
				else printd(ival,gTheFile);
				break;
				
			case 'x':
				ival = va_arg(ap, int32);
				if (!gUseLogFile) kprintf("%08lx",ival);
				else printHex(ival,gTheFile);
				break;
				
			case 's':
				sval = va_arg(ap,char *);
				if (!gUseLogFile) kprintf("%s",sval);
				else fputs( sval, gTheFile);
				break;
			
			case 'c':
				schar = va_arg(ap,char);				
				if (!gUseLogFile) kprintf("%c",schar);
				else putc(schar, gTheFile);
				break;
				
			default:       
				if (!gUseLogFile) kprintf("%c",*p);
				else putc(*p, gTheFile);
				break;
		}
				 
	}
	va_end(ap);
}
   
