// $Id: testMPEG.c,v 1.6 94/05/27 15:58:42 spence Exp $
// Modified for testing - Cyrus Hazari June 1994


#undef	ENABLE_TESTS
#undef	ENABLE_BAT_TESTS
#undef	ENABLE_FT_TESTS
#undef	ENABLE_EST_TESTS
#undef	ENABLE_DT_TESTS
#undef	ENABLE_LST_TESTS
#undef	ENABLE_BT_TESTS
#undef	ENABLE_PT_TESTS

#undef	ENABLE_avGetStreamer_TESTS
#undef	ENABLE_avGetStreamerAbilities_TESTS
#undef	ENABLE_avOpenStreamFile_TESTS
#undef	ENABLE_OpenAVFolio_TESTS
#undef	ENABLE_avRemoveStreamer_TESTS
#undef	ENABLE_avCloseStreamFile_TESTS
#undef	ENABLE_avPlayStream_TESTS
#undef	ENABLE_avStartUserFeedback_TESTS
#undef	ENABLE_avSetStreamPosition_TESTS
#undef	ENABLE_avGetStreamPosition_TESTS
#undef	ENABLE_avChangeVideoAttribute_TESTS
#undef	ENABLE_avRestoreVideoAttribute_TESTS
#undef	ENABLE_avAddDataStreamerPort_TESTS

#undef	AVfolio_0p2
#undef	NetOS1d15_and_up
#undef	NEWSTYLE_VA


#define	ENABLE_TESTS		1
#define	ENABLE_BAT_TESTS	1
#define	ENABLE_FT_TESTS		1
#define	ENABLE_EST_TESTS	1
#define	ENABLE_DT_TESTS		1
#define	ENABLE_LST_TESTS	1
#define	ENABLE_BT_TESTS		1
#define	ENABLE_PT_TESTS		1

#define	ENABLE_OpenAVFolio_TESTS				1
#define	ENABLE_avCloseStreamFile_TESTS			1
#define	ENABLE_avGetStreamer_TESTS				1
#define	ENABLE_avGetStreamerAbilities_TESTS		1
#define	ENABLE_avGetStreamPosition_TESTS		1
//#define	ENABLE_avOpenStreamFile_TESTS			1
#define	ENABLE_avRemoveStreamer_TESTS			1
#define	ENABLE_avPlayStream_TESTS				1

//#define	ENABLE_avGetStreamerAbilitiesV_TESTS	1
//#define	ENABLE_avOpenStreamFileV_TESTS			1
//#define	ENABLE_avRestoreVideoAttribute_TESTS	1
//#define	ENABLE_avSetStreamPosition_TESTS		1
//#define	ENABLE_avSetStreamPositionV_TESTS		1
//#define	ENABLE_avStartUserFeedback_TESTS		1
//#define	ENABLE_avStartUserFeedbackV_TESTS		1
//#define	ENABLE_avAddDataStreamerPort_TESTS		1
//#define	ENABLE_avChangeVideoAttribute_TESTS		1
//#define	ENABLE_avChangeVideoAttributeV_TESTS	1
//#define	ENABLE_avAlterVideoOutput_TESTS			1

#define	AVfolio_0p2		1
#define	NetOS1d15_and_up	1
#define	NEWSTYLE_VA		1


/* 	------------------------------------------------------------------------------------------
	REPORTER
														Globals required by output formatter	*/
#include "scaffold.h"
#include "Globals.h"
/* 	------------------------------------------------------------------------------------------	*/

#include "types.h"
#include "av.h"
#include "event.h"
#include "time.h"
#include "init3do.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "ctype.h"
#include "JoyPad.h"
#include "Open24BitGraphics.h"
#include "directory.h"
#include "directoryfunctions.h"
#include "filefunctions.h"
#include "filestreamfunctions.h"

#define REPORT_ERR(x) {if ((x) < 0) PrintfSysErr(x);}
#define ABLE(x) abilities[(x)]

//#define SHOWDEBUG

#ifdef SHOWDEBUG
#define DPRT(x) {kprintf(x);}
#else
#define DPRT(x)
#endif

#define STT_FILENAME "/remote/system/stt/stt.config"

static char *parse_file( Stream *fp )
{
  static char buff[128];
  char *p, c;

  p = buff;
  buff[0] = 0;

  /* get the first character */
  if( !ReadDiskStream(fp, &c, 1) ) return( buff );

  while( c != '\r' && c != '#' ) {
    *p++ = c;
    if( !ReadDiskStream(fp, &c, 1) )
      c = '\n';
  }

  if( c == '#' )
    while( ReadDiskStream(fp, &c, 1) && c != '\r' )
      ;

  *p = 0; /* null terminate */
  return( buff );
}

uint32 inet_addr( char *cp )
{
  register uint32 val, base, n;
  register char c;
  uint32 parts[4], *pp = parts;
  
//  SPRT(("inet_addr: %s\n",cp));
  
 again:
  /*
   * Collect number up to ``.''.
   * Values are specified as for C:
   * 0x=hex, 0=octal, other=decimal.
   */
  val = 0; base = 10;
  if (*cp == '0') {
    if (*++cp == 'x' || *cp == 'X')
      base = 16, cp++;
    else
      base = 8;
  }
  while ( (c = *cp) != 0 ) {
    if (isdigit(c)) {
      val = (val * base) + (uint32)(c - '0');
      cp++;
      continue;
    }
    if (base == 16 && isxdigit(c)) {
      val = (val << 4) + (uint32)(c + 10 - (islower(c) ? 'a' : 'A'));
      cp++;
      continue;
    }
    break;
  }
  if (*cp == '.') {
    /*
     * Internet format:
     *	a.b.c.d
     *	a.b.c	(with c treated as 16-bits)
     *	a.b	(with b treated as 24 bits)
     */
    if (pp >= parts + 4)
      return ( 0 );
    *pp++ = val, cp++;
    goto again;
  }
  /*
   * Check for trailing characters.
   */
  if (*cp && !isspace(*cp))
    return ( 0 );
  *pp++ = val;
  /*
   * Concoct the address according to
   * the number of parts specified.
   */
  n = pp - parts;
  switch (n) {
    
  case 1:				/* a -- 32 bits */
    val = parts[0];
    break;
    
  case 2:				/* a.b -- 8.24 bits */
    val = (parts[0] << 24) | (parts[1] & 0xffffff);
    break;
    
  case 3:				/* a.b.c -- 8.8.16 bits */
    val = (parts[0] << 24) | ((parts[1] & 0xff) << 16) |
      (parts[2] & 0xffff);
    break;
    
  case 4:				/* a.b.c.d -- 8.8.8.8 bits */
    val = (parts[0] << 24) | ((parts[1] & 0xff) << 16) |
      ((parts[2] & 0xff) << 8) | (parts[3] & 0xff);
    break;
    
  default:
    return ( 0 );
  }
//  val = htonl(val);
//  SPRT(("inet_addr: val = 0x%lx\n",val));
  return (val);
}

/*********************************************************************/

int main(int argc, char *argv[])
{
	Err err;
	Item streamer;
	Item stream;
	JoyPadState jp;
	char filenameBuild[32];
	char *filename;
	char *serverIP = "192.33.138.1", *iisIP = "192.33.138.2";
	char *clientIP = "192.33.138.57";
	char sttServer[16], sttiis[16], client[16];
	int32 track = -1;
	Item vbl;
	struct timeval tv = {5, 0};
	int32 i,j;
	int32 depth = 0;
	int32 port = 3001;
	Item endMsgPort;
	Item endMsg = 0;
	TagArg getAbilities[] =	/* What this streamer is capable of */
	{
		{AV_TAG_ABLE_PLAY, NULL},
		{AV_TAG_ABLE_PAUSE, NULL},
		{AV_TAG_ABLE_GETSTREAMPOS, NULL},
		{AV_TAG_ABLE_FFWD, NULL},
		{AV_TAG_ABLE_REW, NULL},
		{AV_TAG_ABLE_SETSTREAMPOS, NULL},
		{TAG_END},
	};
	TagArg osf_tags[6];
	ScreenContext sc;
	avBitmapInfo avbi;
	Item screenGroupI = 0;
	Stream *fp;
	bool open = FALSE;
	bool loop = TRUE;
	bool pause = FALSE;
	bool quick = FALSE;
	bool whitebook = FALSE;
	bool allocateScreen = FALSE;
	bool DMAmode = FALSE;
	bool abilities[16];

#ifdef ENABLE_TESTS
/* 	------------------------------------------------------------------------------------------
	REPORTER
																Initialize output formatter		*/
#include "InitDepthTest.h"
/* 	------------------------------------------------------------------------------------------	*/
#endif

	#include "Test_OpenAVFolio.c"	
	if ((err = OpenAVFolio()) < 0)
	{
		PrintfSysErr(err);
		exit(err);
	}

	if ((err = OpenGraphicsFolio()) < 0)
	{
		CloseAVFolio();
		PrintfSysErr(err);
		exit(err);
	}

	vbl = GetVBLIOReq();

	filename = argv[1];

	if (((argc > 1) && (*argv[1] == '?')) ||
	         (argc == 1))
	{
		kprintf("Usage: either a filename,\n");
		kprintf("or -n <trackNumber>,\n");
		kprintf("-d [16|24] for depth\n");
		kprintf("-w for WhitebookCD version\n");
		kprintf("-s screen allocated by this app, not the streamer\n");
		kprintf("-r seRverIP number\n");
		kprintf("-i Iis IP number\n");
		kprintf("-c Client IP number\n");
		kprintf("-p port number\n");
		kprintf("-x DMA mode\n");
		CloseAVFolio();
		exit(0);
	}

	fp = OpenDiskStream(STT_FILENAME, 0);
	if (fp)
	{
		strcpy(sttiis, parse_file(fp));
		iisIP = sttiis;
		strcpy(sttServer, parse_file(fp));
		serverIP = sttServer;
		strcpy(client, parse_file(fp));
		clientIP = client;
		port = strtoul(parse_file(fp), NULL, 10);
		printf("From stt.config:\n");
		printf("iis = %s\n", iisIP);
		printf("server = %s\n", serverIP);
		printf("client = 0x%lx\n", clientIP);
		printf("port = %ld\n", port);
		CloseDiskStream(fp);
	}
	else
	{
		printf("Error opening %s\n", STT_FILENAME);
	}

	for (i = 1; i < argc; i++)
	{
		if (strcmp(argv[i], "-n") == 0)
		{
			track = atoi(argv[++i]); 
			strcat(filenameBuild, "track");
			strcat(filenameBuild, argv[i]);
			filename = filenameBuild;
		}

		if (strncmp(argv[i], "-d", 2) == 0)
		{
			depth = atoi(argv[++i]);
		}

		if (strcmp(argv[i], "-w") == 0)
		{
			whitebook = TRUE;
		}

		if (strcmp(argv[i], "-s") == 0)
		{
			allocateScreen = TRUE;
		}

		if (strcmp(argv[i], "-r") == 0)
		{
			serverIP = argv[++i];
			kprintf("server IP = %s\n", serverIP);
		}

		if (strcmp(argv[i], "-c") == 0)
		{
			clientIP = argv[++i];
			kprintf("client IP = %s\n", clientIP);
		}

		if (strcmp(argv[i], "-i") == 0)
		{
			iisIP = argv[++i];
			kprintf("iis IP = %s\n", iisIP);
		}

		if (strcmp(argv[i], "-p") == 0)
		{
			port = atoi(argv[++i]);
			kprintf("port = %ld\n", port);
		}

		if (strcmp(argv[i], "-x") == 0)
		{
			DMAmode = TRUE;
		}
	}

	endMsgPort = CreateMsgPort(NULL, 0, 0);
	DPRT(("@@@ endMsgPort = 0x%lx\n", endMsgPort));

	/* Get the streamer. This is AV_VIDEOCD_NAME for now, but can change
	 * this to AV_CABLE_DIGITAL_NAME when the MPEG Cable system works.
	 */
	#include "Test_avGetStreamer.c"
	if (whitebook)
	{
		kprintf("Opening CD streamer\n");
		streamer = avGetStreamer(AV_VIDEOCD_NAME);
	}
	else
	{
		kprintf("Opening Cable streamer\n");
		streamer = avGetStreamer(AV_CABLE_DIGITAL_NAME);
	}
	kprintf("streamer = 0x%lx\n", streamer);

	#include "Test_OpenAVFolio.c"	

	if (streamer > 0)
	{
		#include "Test_avGetStreamerAbilities.c"
		/* Get the abilities */
		for (i = 0; i < ((sizeof(getAbilities) / sizeof(TagArg)) - 1); i++)
		{
			getAbilities[i].ta_Arg = (void *)&abilities[i];
		}
		avGetStreamerAbilities(streamer, getAbilities);
		for (i = 0; i < (sizeof(getAbilities) / sizeof(TagArg)); i++)
		{
			DPRT(("Able %ld = %s\n", i, (abilities[i] ? "TRUE" : "FALSE")));
		}

		if (allocateScreen)
		{
			/* 16 bit NYI */
			screenGroupI = Open24BitGraphics(&sc, 2);
			if (screenGroupI > 0)
			{
				printf("@@@ Allocated screen\n");
				avbi.avbi_bitmapVisible = 0;
				avbi.avbi_bitmapCount = 4;
				avbi.avbi_bpp = 24;
				for (i = 0; i < 4; i++)
				{
					avbi.avbi_bitmaps[i] = sc.sc_Bitmaps[i];
					avbi.avbi_ScreenI[i] = sc.sc_Screens[i];
				}
			}
			else
			{
				PrintfSysErr(screenGroupI);
				loop = FALSE;
			}
		}

		while (loop)
		{
			if ((!open) && (filename))
			{
				int32 t = 0;
				if (screenGroupI > 0)
				{
					osf_tags[t].ta_Tag = AV_TAG_OSF_BITMAPS;
					osf_tags[t].ta_Arg = (void *)&avbi;
					t++;
				}
				if (!whitebook)
				{
					osf_tags[t].ta_Tag = AV_TAG_OSF_CABLED_SERVERIP;
					osf_tags[t].ta_Arg = (void *)serverIP;
					t++;
					osf_tags[t].ta_Tag = AV_TAG_OSF_CABLED_CLIENTIP;
					osf_tags[t].ta_Arg = (void *)clientIP;
					t++;
					osf_tags[t].ta_Tag = AV_TAG_OSF_CABLED_PORT;
					osf_tags[t].ta_Arg = (void *)port;
					t++;
					osf_tags[t].ta_Tag = AV_TAG_OSF_CABLED_IISIP;
					osf_tags[t].ta_Arg = (void *)iisIP;
					t++;
					sprintf(filename, "%ld", track);
					kprintf("Opening file number %s\n", filename);
				}
				else
				{
					kprintf("Opening file %s\n", filename);
				}
				if (depth)
				{
					osf_tags[t].ta_Tag = ((depth == 16) ?  AV_TAG_OSF_DISPLAY16BPP : AV_TAG_OSF_DISPLAY24BPP);
					t++;
				}
				if (DMAmode)
				{
					osf_tags[t].ta_Tag = AV_TAG_OSF_CABLED_VDMA;
					t++;
				}
				osf_tags[t].ta_Tag = TAG_END;
				#include "Test_avOpenStreamFile.c"			
				stream = avOpenStreamFile(streamer, filename, endMsgPort, osf_tags);

				#ifdef BADMIA
				/* Set the Mia's clock */
				{
					Item badMia;
					WaitVBL(vbl, (60 * 6));
					badMia = LoadProgramPrio("writedevice -av110 0x6e 0x8", 101);
					if (badMia < 0)
					{
						PrintfSysErr(badMia);
					}
					else
					{
						printf("Mia fixer task 0x%lx\n", badMia);
					}
				}
				#endif

				REPORT_ERR(stream);
				if (open = (stream > 0))
				{
					err = avPlayStream(stream, AV_RATE_NORMAL, TRUE);
					#include "Test_avPlayStream.c"
					REPORT_ERR(err);
					quick = FALSE;
				}
				else
				{
					loop = FALSE;
				}
			}
	
			if (stream > 0)
			{
				GetJoyPad(&jp, 1);

				if (endMsg = GetMsg(endMsgPort))
				{
					printf("@@@ End of the stream\n");
					ReplyMsg(endMsg, 0, NULL, 0);
					jp.xBtn = 1;	/* Force the CloseStream code */
				}

				if (jp.xBtn)
				{
					DPRT(("@@@ Closing stream\n"));
					err = avCloseStreamFile(stream);
					REPORT_ERR(err);
					open = FALSE;
					filename = NULL;
				}				
	
				if ((jp.upArrow) && (ABLE(3)))
				{
					DPRT(("@@@ FFWD\n"));
					err = avPlayStream(stream, AV_RATE_FFWD, TRUE);
					REPORT_ERR(err);
					if (err >= 0)
					{
						quick = TRUE;
					}
				}
	
				if ((jp.downArrow) && (ABLE(4)))
				{
					DPRT(("@@@ Rewind\n"));
					err = avPlayStream(stream, AV_RATE_REWIND, TRUE);
					REPORT_ERR(err);
					if (err >= 0)
					{
						quick = TRUE;
					}
				}
	
				if ((jp.leftArrow) && (ABLE(5)))
				{
					DPRT(("@@@ Back to the beginning\n"));
#ifdef NEWSTYLE_VA
					err = avSetStreamPositionVA(stream, 0, TRUE,
					                           AV_TAG_SSP_BLOCKS, 0,
					                           TAG_END);
#else
					err = avSetStreamPositionV(stream, 0, TRUE,
					                           AV_TAG_SSP_BLOCKS, 0,
					                           TAG_END);
#endif
					REPORT_ERR(err);
				}

				if ((jp.leftShift) && (ABLE(5)))
				{
					DPRT(("@@@ back 5 secs\n"));
					tv.tv_sec = -5;
#ifdef NEWSTYLE_VA
					err = avSetStreamPositionVA(stream, AV_F_SETSTREAMPOS_DELTA, TRUE,
					                           AV_TAG_SSP_ABSTIME, (void *)&tv,
					                           TAG_END);
#else
					err = avSetStreamPositionV(stream, AV_F_SETSTREAMPOS_DELTA, TRUE,
					                           AV_TAG_SSP_ABSTIME, (void *)&tv,
					                           TAG_END);
#endif
					REPORT_ERR(err);
				}

				if ((jp.rightShift) && (ABLE(5)))
				{
					DPRT(("@@@ forward 5 secs\n"));
					tv.tv_sec = 5;
#ifdef NEWSTYLE_VA
					err = avSetStreamPositionVA(stream, AV_F_SETSTREAMPOS_DELTA, TRUE,
					                           AV_TAG_SSP_ABSTIME, (void *)&tv,
					                           TAG_END);
#else
					err = avSetStreamPositionV(stream, AV_F_SETSTREAMPOS_DELTA, TRUE,
					                           AV_TAG_SSP_ABSTIME, (void *)&tv,
					                           TAG_END);
#endif
					REPORT_ERR(err);
				}
	
				if ((jp.aBtn) && (track > 0))
				{
					err = avCloseStreamFile(stream);
					REPORT_ERR(err);
					track++;
					sprintf(filenameBuild, "track%ld", track);
					filename = filenameBuild;
					open = FALSE;
				}
	
				if ((jp.bBtn) && (ABLE(2)))
				{
					TagArg gsp[] =
					{
						{AV_TAG_GSP_FIELDS, NULL},
						{AV_TAG_GSP_ABSTIME, NULL},
						{AV_TAG_GSP_BYTES, NULL},
						{AV_TAG_GSP_BLOCKS, NULL},
						{TAG_END, NULL},
					};
					struct timeval *tv;
					avPoint avp = {40, 40, 0};

					DPRT(("@@@ Get position\n"));
#ifdef NEWSTYLE_VA
					err = avStartUserFeedbackVA(stream,
					      AV_TAG_UF_TIME, NULL,
					      AV_TAG_UF_POSITION, &avp,
					      TAG_END, NULL);
#else
					err = avStartUserFeedbackV(stream,
					      AV_TAG_UF_TIME, NULL,
					      AV_TAG_UF_POSITION, &avp,
					      TAG_END, NULL);
#endif
					if (err < 0)
					{
						PrintfSysErr(err);
					}

					#include "Test_avGetStreamPosition.c"			
					err = avGetStreamPosition(stream, gsp);
					if (err >= 0)
					{
						kprintf("Fields = %ld\n", gsp[0].ta_Arg);
						tv = (struct timeval *)gsp[1].ta_Arg;
						kprintf("Time  = %ld.%ld secs\n", tv->tv_sec, tv->tv_usec);
						kprintf("Bytes = %ld\n", gsp[2].ta_Arg);
						kprintf("Blocks = %ld\n", gsp[3].ta_Arg);
					}
					else
					{
						PrintfSysErr(err);
					}
				}

				if (jp.cBtn)
				{
					DPRT(("@@@ close stream\n"));
					err = avCloseStreamFile(stream);
					REPORT_ERR(err);
					open = FALSE;
					loop = FALSE;
				}
	
				if ((jp.startBtn) && (ABLE(1)))
				{
					if ((pause) || (quick))
					{
						DPRT(("@@@ play normal\n"));
						err = avPlayStream(stream, AV_RATE_NORMAL, TRUE);
						REPORT_ERR(err);
						quick = FALSE;
						pause = FALSE;
					}
					else
					{
						DPRT(("@@@ pause\n"));
						err = avPlayStream(stream, AV_RATE_PAUSE, TRUE);
						REPORT_ERR(err);
						pause = TRUE;
					}
				}
			}
			else
			{
				PrintfSysErr(stream);
				loop = FALSE;
			}
			WaitVBL(vbl, 2);
		}
		DPRT(("@@@ remove streamer\n"));
		#include "Test_avRemoveStreamer.c"
		err = avRemoveStreamer(streamer);
		if (err < 0)
		{
			PrintfSysErr(err);
		}
	}
	else
	{
		PrintfSysErr(streamer);
	}

	if (screenGroupI > 0)
	{
		Close24BitGraphics(&sc, screenGroupI);
	}

	DeleteItem(vbl);
	CloseAVFolio();
	kprintf("See ya\n");
	exit(0);
}
