
/******************************************************************************************************************/
#ifdef ENABLE_TESTS
#ifdef ENABLE_avOpenStreamFile_TESTS
	/* 	------------------------------------------------------------------------------------------
		TEST: 		Exercise avOpenStreamFile()
		TYPE:		BAT / FT / EST / DT / LST
		------------------------------------------------------------------------------------------	*/
		{
			#include ":DATA:DepthTest_avOpenStreamFile.h"
			int32		p[10];
			Item		fileItem, stream;
			int32		closeItem;
			Boolean		normalAbilities[16];
			uint32		normalTags[16], theTagFound;
			Boolean		foundTag, foundCorrectValue;
static		Item		msgPort;
			int32		signal1, iii;
			Err			TheErr;
			
			gProgName 	= "AVtest.c";
			gTestName 	= "avOpenStreamFile";
			gTestLevel 	= DEPTH;
			gTestType 	= AUTOMATED;
			
			// Create a message port so that we are notified of the invoked task's termination
			signal1 = AllocSignal( 0 );
			msgPort = CreateMsgPort( "HomePort", 0, signal1 );

			BlockEnter();
			SetPassed();
#ifdef ENABLE_BAT_TESTS
			#include "DepthTest_TopPortion.h"
			#include "DepthTest_BottomPortion.h"
#endif
#ifdef ENABLE_FT_TESTS
			#include "DepthTest_TopPortion.h"
		kprintf("avOpenStreamFile() - ENABLE_FT_TESTS\n",ARGUMENT_02 );
			stream = avOpenStreamFile( streamer, filename, msgPort, osf_tags );
			if( stream <= 0 )
			{
				SetTestResult( FAILED, "FT - avOpenStreamFile() failed unexpectedly.\n" );
				goto cleanup_osf1;
			}
		kprintf("avCloseStreamFile() - ENABLE_FT_TESTS\n",ARGUMENT_02 );
			TheErr = avCloseStreamFile( stream );
			if( TheErr < 0 )
			{
				SetTestResult( FAILED, "FT - avCloseStreamFile() failed unexpectedly with error code %d 0x%x.\n", TheErr,TheErr );
				goto cleanup_osf1;
			}
			#include "DepthTest_BottomPortion.h"
cleanup_osf1:
			stream = 0;
#endif
#ifdef ENABLE_EST_TESTS
#ifndef AVfolio_0p2		// AVFolio 0.2 can't handle this
			// It used to hang when I passed a NULL instead of a valid streamer item
		kprintf("EST - avOpenStreamFile() here comes the NULL streamer ID.....\n" );
			stream = avOpenStreamFile( 0, filename, endMsgPort, osf_tags );
			if( stream > 0 )
			{
				SetTestResult( FAILED, "EST - avOpenStreamFile( NULL, <goodFilename>, <goodMsgPort>, <goodTagArgs> ) did not catch the erroneous streamer item.\n" );
			}

			#include "DepthTest_TopPortion.h"
	//	kprintf("avOpenStreamFile( %x, %s, endMsgPort, osf_tags )\n",ARGUMENT_01,filename,p[4] );
			stream = avOpenStreamFile( ARGUMENT_01, filename, endMsgPort, osf_tags );
			if( stream > 0 )
			{
				SetTestResult( FAILED, "EST - avOpenStreamFile( %x, <goodFilename>, <goodMsgPort>, <goodTagArgs> ) did not catch the erroneous streamer item.\n", ARGUMENT_01 );
			}
			#include "DepthTest_BottomPortion.h"
#endif
			#include "DepthTest_TopPortion.h"
		kprintf("avOpenStreamFile( streamer, %s, endMsgPort, osf_tags )\n",ARGUMENT_02 );
			stream = avOpenStreamFile( streamer, ARGUMENT_02, endMsgPort, osf_tags );
			if( stream > 0 )
			{
				SetTestResult( FAILED, "EST - avOpenStreamFile( <goodStreamer>, %s, <goodMsgPort>, <goodTagArgs> ) did not catch the bad filename.\n", ARGUMENT_02 );
			}
			#include "DepthTest_BottomPortion.h"
			#include "DepthTest_TopPortion.h"
		kprintf("avOpenStreamFile( streamer, %s, %x, osf_tags )\n",filename,ARGUMENT_02 );
			stream = avOpenStreamFile( streamer, filename, ARGUMENT_03, osf_tags );
			if( stream > 0 )
			{
				SetTestResult( FAILED, "EST - avOpenStreamFile( <goodStreamer>, <goodFilename>, %x, <goodTagArgs> ) did not catch the bad message port.\n", ARGUMENT_03 );
			}
			#include "DepthTest_BottomPortion.h"
			#include "DepthTest_TopPortion.h"
		kprintf("avOpenStreamFile( streamer, %s, endMsgPort, %x )\n",filename,ARGUMENT_04 );
			stream = avOpenStreamFile( streamer, filename, endMsgPort, ARGUMENT_04 );
			if( stream > 0 )
			{
				SetTestResult( FAILED, "EST - avOpenStreamFile( <goodStreamer>, <goodFilename>, <goodMsgPort>, %s ) did not catch the bad TagArgs array.\n", ARGUMENT_04 );
			}
			#include "DepthTest_BottomPortion.h"
#endif
#ifdef ENABLE_DT_TESTS
			#include "DepthTest_TopPortion.h"
			#include "DepthTest_BottomPortion.h"
#endif
#ifdef ENABLE_LST_TESTS
			for(iii=0;iii<20;iii++)
			{
				#include "DepthTest_TopPortion.h"
				stream = avOpenStreamFile( streamer, filename, msgPort, osf_tags );
				if( stream <= 0 )
				{
					SetTestResult( FAILED, "LST - avOpenStreamFile() failed as a result of being called multiple times in succession.\n" );
					goto cleanup_osf2;
				}
				#include "DepthTest_BottomPortion.h"
			}
cleanup_osf2:
			stream = 0;
#endif
			BlockExit();
		}

	/*	------------------------------------------------------------------------------------------	*/
#endif	/* ENABLE_avGetStreamerAbilities_TESTS */
#endif	/* ENABLE_TESTS */
/******************************************************************************************************************/

