/*
	File:		DatabaseTest.c

	Contains:	The main routine for dtabase folio testing

	Written by:	Eric Hegstrom

	Copyright:	 1994 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 3/15/94	ELH		Created

	To Do:
*/

//#include "scaffold.h"
#include "scaffold_HACK.h"
#include "TestSpec.h"
#include "DataBaseTest.h"
#include "TSReporter.h"
#include "template.h"


//Item	curDBItem;			// the cuurent Item of the open database
Handle	curDBItem;			// the cuurent Item of the open database
Item	netItem;			// the cuurent Item of the open network connection
Item	curRecList;			// the current record list in use
uint32	sizeCurRecList;		// number of records in the curRecList

int32	iteration = 1;
int32	n = 1;

int main (void )
{
	uint32	tIndx;
	uint32	dIndx;
	
	char	tc[255];
	int32	n;
	Err		myError;



//	ReportInit(true);					// initialize logging and reporting system
	ReportInit(true);					// initialize logging and reporting system
	
	
	gProgName = "Database Test";   /* contains the name of the program */
	gTestLevel = BREADTH;			/* contains what level of testing occurs in this test */
	gTestType = AUTOMATED;			/* interactive or automated */
	
	
	
		
	// ---------------------------------------------------------------------------------------------	
	// 	 	OpenDatabaseFolio Test
	gTestName = "OpenDatabaseFolio Test";			
	BlockEnter();							/* initializes this block */
	myError = OpenDatabaseFolio();
	if ( myError != 0 ) 
	{
		PrintfSysErr(myError);
		SetTestResult("OpenDatabaseFolio Failed", FAILED);
		Report("FAILURE OPENING DATABASE FOLIO Unable to continue !\n");
		BlockExit();
		return -1;
	}
	BlockExit();
		
//	ReportTerm();
		
while (true) {
//for( n=1; n<=3; n++) {
//	ReportInit(true);					// initialize logging and reporting system
	
	Report(" =======  ITERATION # %d  =========\n", iteration);
	kprintf(" %d\n", iteration);
	
	iteration++;
		

	// ---------------------------------------------------------------------------------------------	
	// 			OpenDataBase Test
	for( tIndx = 0; tIndx < NUM_DB_TESTS; tIndx++ ) {
		gTestName = "OpenDataBase ";
//		strcat( gTestName, TestSpec[tIndx].TestName );	// set up the test name 
		BlockEnter();									/* initializes this block */
		
		
		curDBItem = OpenDataBase( TestSpec[tIndx].DataBaseName );
		if (DBDEBUG) Report( "OpenDataBase(%s) returns %x\n", TestSpec[tIndx].DataBaseName, curDBItem );
		if ( curDBItem <= 0 ) {
			if ( OpenDataBaseResults[ tIndx ] == NO_ERROR ) {
				SetTestResult("OpenDataBaseFolio Failed", FAILED);
			}
		}
		else {
			if ( OpenDataBaseResults[ tIndx ] == ERROR ) {
				SetTestResult("UNEXPECTED PASS", FAILED);
			}
			if( CloseDataBase( curDBItem ) != 0) Report( "Error closing database !\n");
			if (DBDEBUG) Report( "CloseDataBase(%x) \n",  curDBItem );
		}
		BlockExit();
	}
	
	
	// ---------------------------------------------------------------------------------------------	
	// 			OpenRecords Test
	for( tIndx = 0; tIndx < NUM_DB_TESTS; tIndx++ ) {
		gTestName = "OpenRecords ";
//		strcat( gTestName, TestSpec[tIndx].TestName );	// set up the test name 
		BlockEnter();				/* initializes this block */
		
		if ( SetupOpenRecords(tIndx) <= 0 ) {
			SetTestResult("SetupOpenRecords Failed", UNRESOLVED);
		}
		else {
			if ( TestOpenRecords(tIndx) <= 0) {
				if ( OpenRecordsResults[ tIndx ] == NO_ERROR ) {
					SetTestResult("TestOpenRecords Failed", FAILED);
				}
			}
			else {
				if ( OpenRecordsResults[ tIndx ] == ERROR ){
					SetTestResult("UNEXPECTED NO_ERROR", FAILED);
				}
				if ( CleanupOpenRecords() ) Report( "Error in CleanupOpenRecords --!\n");
			}
		}	
		BlockExit();
	}
	
	
	// ---------------------------------------------------------------------------------------------	
	// 			ExamineRecords Test
	for( tIndx = 0; tIndx < NUM_DB_TESTS; tIndx++ ) {
		gTestName = "ExamineRecords ";
//		strcat( gTestName, TestSpec[tIndx].TestName );	// set up the test name 
		BlockEnter();				/* initializes this block */
		
		if ( SetupExamineRecords(tIndx) <= 0 ) {
			SetTestResult("SetupExamineRecords Failed", UNRESOLVED);
		}
		else {
			if ( !TestExamineRecords(tIndx) ) {
				if ( ExamineRecordsResults[ tIndx ] == NO_ERROR ) {
					SetTestResult("TestExamineRecords Failed", FAILED);
				}
			}
			else {
				if ( ExamineRecordsResults[ tIndx ] == ERROR ) {
					SetTestResult("UNEXPECTED NO_ERROR", FAILED);
				}
				if ( CleanupExamineRecords() )  Report( "Error in CleanupExamineRecords --!\n");
			}
		}
		BlockExit();
	}
		
		


	
//  ---------------
//  NOTE:	
//  Uncomment the following section when modification of records is supported
//     - Eric Hegstrom 4-94
	
	
	// ---------------------------------------------------------------------------------------------	
	// 			ModifyRecords Test
//	for( tIndx = 0; tIndx < NUM_DB_TESTS; tIndx++ ) {
//		gTestName = "ModifyRecords ";
//		strcat( gTestName, TestSpec[tIndx].TestName );	// set up the test name 
//		BlockEnter();				/* initializes this block */
//		
//		if ( SetupModifyRecords(tIndx) <= 0 )
//			SetTestResult("SetupModifyRecords Failed", UNRESOLVED);
//		else {	
//			if ( TestModifyRecords(tIndx) ) {
//				if ( ModifyRecordsResults[ tIndx ] == NO_ERROR )
//					SetTestResult("TestModifyRecords Failed", FAILED);
//			}
//			else {
//				if ( ModifyRecordsResults[ tIndx ] == ERROR ) {
//					SetTestResult("UNEXPECTED NO_ERROR", FAILED);
//				}
//				if ( CleanupModifyRecords() )  Report( "Error in CleanupModifyRecords --!\n");
//			}
//		}
//		BlockExit();
//	}
	
	
	// ---------------------------------------------------------------------------------------------	
	// 			LockRecords Test
//	for( tIndx = 0; tIndx < NUM_DB_TESTS; tIndx++ ) {
//		gTestName = "LockRecords ";
//		strcat( gTestName, TestSpec[tIndx].TestName );	// set up the test name 
//		BlockEnter();				/* initializes this block */
//		
//		if ( SetupLockRecords(tIndx) <= 0 )
//			SetTestResult("SetupLockRecords Failed", UNRESOLVED);
//		else {	
//			if ( TestLockRecords(tIndx) ) {
//				if ( LockRecordsResults[ tIndx ] == NO_ERROR )
//					SetTestResult("TestLockRecords Failed", FAILED);
//			}
//			else {
//				if ( LockRecordsResults[ tIndx ] == ERROR ) {
//					SetTestResult("UNEXPECTED NO_ERROR", FAILED);
//				}
//				if ( CleanupLockRecords() ) Report( "Error in CleanupLockRecords --!\n");
//			}
//		}
//		BlockExit();
//	}
					
		
	
//	ReportTerm();
}	
//	ReportInit(true);
	
// ---------------------------------------------------------------------------------------------	
	// 			CloseDatabaseFolio Test
	gTestName = "CloseDatabaseFolio Test";		
	BlockEnter();							/* initializes this block */
	if ( CloseDatabaseFolio() != 0 ) {
		SetTestResult("CloseDatabaseFolio Failed", FAILED);
	}
	BlockExit();
	
	
				
	ReportTerm();
	


}
