/*
	File:		OpenRecords.c

	Contains:	

	Written by:	Eric Hegstrom

	Copyright:	 1994 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <1>	 3/15/94	ELH		Created

	To Do:
*/

#include "TestSpec.h"
#include "globals.h"
#include "TSReporter.h"

// ---------------------------------------------
Item	SetupOpenRecords( int32 indx )
{
	curDBItem = OpenDataBase( TestSpec[indx].DataBaseName );
	if (DBDEBUG) Report( "OpenDataBase(%s) returns %x\n", TestSpec[indx].DataBaseName, curDBItem );
	return curDBItem;
}

// ---------------------------------------------
Item	TestOpenRecords( int32 indx )
{
	SearchQuery queryRec;
	
	queryRec.SearchType = TestSpec[indx].SearchType;
	
	switch ( TestSpec[indx].SearchType ) {
				case (SQTYPE_BYLOGICAL):	queryRec.Form.QueryString = TestSpec[indx].Form.QueryString;
											break;
											
				case (SQTYPE_BYOBJHANDLE):	queryRec.Form.ObjectHandle = TestSpec[indx].Form.ObjectHandle;
											break;
											
				case (SQTYPE_BYPRIMARYKEY):	queryRec.Form.PrimaryKey = TestSpec[indx].Form.PrimaryKey;
											break;
	}
	
	queryRec.SearchSet = (Handle) NULL;	

	curRecList = OpenRecords( curDBItem, &queryRec, TestSpec[indx].QueryFields, TestSpec[indx].NumQueryFields,
									&sizeCurRecList);
	if (curRecList <= 0 ){
		if (DBDEBUG) Report( "OpenRecords (dbItem = %x ) in Open Records FAILED err#%d\n", curDBItem, curRecList);		
		Report( "OpenRecords in Examine Records failed err#%d\n", curRecList);		
	}
	else {
		if (DBDEBUG) Report( "OpenRecords returns %x (dbItem = %x )(curRecList = %x);(%d Records Returned)\n", curRecList, curDBItem,curRecList, sizeCurRecList );		
	}
	return curRecList;
}

// ---------------------------------------------
Boolean	CleanupOpenRecords( void )
{
	Err		err, err2;

	err = CloseRecords( curRecList );
	if (DBDEBUG) Report("CloseRecords(%x) returns %x\n", curRecList, err );
	err2 = CloseDataBase( curDBItem );
	if (DBDEBUG) Report("CloseDataBase(%x) returns %x\n", curDBItem, err2 );
	
	return (err || err2);
}

