/* $Id: timerutilsexample.c,v 1.3 1994/05/27 19:56:31 vertex Exp $ */

/* This simple program creates an interval timer, samples the timer for
 * the current time, counts to 1 million, samples the timer again, and
 * prints the difference between the two times, which gives the amount of
 * time it took to count to 1 million.
 */

#include "types.h"
#include "time.h"
#include "stdio.h"
#include "timerutils.h"


/*****************************************************************************/


int32 external;


int main(int argc, char **argv)
{
IntervalTimer  *timer;
struct timeval  tv;
uint32          i;

    timer = CreateIntervalTimer();
    if (timer)
    {
        for (i = 0; i < 1500000; i++)
            external++;

        SampleIntervalTimer(timer,&tv);

        printf("Counting to 1.5 million took %d.%06d seconds\n",tv.tv_sec,tv.tv_usec);

        DeleteIntervalTimer(timer);
    }
    else
    {
        printf("Could not create interval timer!\n");
    }

    return (0);
}
