#include "rpc_rpc.h"
#include "divide.h"

/* define the IP address of the server to use */
#define SERVER "192.33.138.1"

main( int argc, char **argv )
{
  CLIENT *cl;
  char **result;
  args foo;
  
  if( argc != 3 ) {
    printf("Usage: divide x y\n");
    exit(1 );
  }

  if( OpenNetworkFolio() < 0 ) {
    printf("Cannot open network folio\n");
    exit(1);
  }

	printf("Opened NetworkFolio successfully...\n");

  foo.x = atoi( argv[1] );
  foo.y = atoi( argv[2] );

  cl = clnt_create( SERVER, DIVIDEPROG, DIVIDEVERS, "udp" );
  if( cl == NULL ) {
    clnt_pcreateerror( SERVER );
    exit( 1 );
  }
  
  	printf("Called clnt_create successfully...\n");
  	printf("Waiting for rpc to complete...\n");


  result = divide_1( &foo, cl );
  if( result == NULL ) {
    /* an error occurred while calling the remote function */
    clnt_perror( cl, SERVER );
    exit( 1 );
  }
  
  	printf("Divide rpc completed successfully...\n");

  printf(" %d / %d = %s\n", foo.x, foo.y, *result );
}
